/*
    This file is a part of the SteamWar software.

    Copyright (C) 2021  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.utils;

import de.steamwar.fightsystem.Config;
import de.steamwar.fightsystem.fight.FightWorld;
import net.minecraft.server.v1_10_R1.Chunk;
import org.bukkit.World;
import org.bukkit.craftbukkit.v1_10_R1.CraftWorld;
import org.bukkit.craftbukkit.v1_10_R1.entity.CraftEntity;
import org.bukkit.entity.Entity;

import java.util.stream.Stream;

public class CraftbukkitWrapper10 implements CraftbukkitWrapper {
    @Override
    public void resetChunk(World world, World backup, int x, int z) {
        net.minecraft.server.v1_10_R1.World w = ((CraftWorld) world).getHandle();
        Chunk chunk = w.getChunkAt(x, z);
        Chunk backupChunk = ((CraftWorld) backup).getHandle().getChunkAt(x, z);

        System.arraycopy(backupChunk.getSections(), 0, chunk.getSections(), 0, chunk.getSections().length);
        System.arraycopy(backupChunk.heightMap, 0, chunk.heightMap, 0, chunk.heightMap.length);
        w.tileEntityListTick.removeAll(chunk.tileEntities.values());
        if (!FightWorld.isPAPER()) {
            w.tileEntityList.removeAll(chunk.tileEntities.values());
        }
        chunk.tileEntities.clear();
        chunk.tileEntities.putAll(backupChunk.tileEntities);
    }

    @Override
    public float headRotation(Entity e) {
        return ((CraftEntity)e).getHandle().getHeadRotation();
    }

    @Override
    public Stream<?> entityIterator() {
        return ((CraftWorld) Config.world).getHandle().entityList.stream();
    }
}
