/*
    This file is a part of the SteamWar software.

    Copyright (C) 2021  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.utils;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.scoreboard.Team;

public class WorldOfColorWrapper8 implements WorldOfColorWrapper {
    @Override
    public void setTeamColor(Team team, ChatColor color) {
        team.setPrefix("§" + color.getChar());
    }

    @Override
    public boolean isInBlock(Projectile e) {
        return false;
    }

    @Override
    public void playSound(Location location, Sound sound, String soundCategory, float volume, float pitch) {
        location.getWorld().playSound(location, sound, volume, pitch);
    }

    @SuppressWarnings("deprecation")
    @Override
    public void sendTitle(Player player, String title, String subtitle, int start, int hold, int stop) {
        player.sendTitle(title, subtitle);
    }
}
