package de.steamwar.fightsystem.commands;

import de.steamwar.fightsystem.ArenaMode;
import de.steamwar.fightsystem.Config;
import de.steamwar.fightsystem.FightSystem;
import de.steamwar.fightsystem.fight.Fight;
import de.steamwar.fightsystem.fight.FightTeam;
import de.steamwar.fightsystem.states.FightState;
import de.steamwar.fightsystem.states.StateDependentCommand;
import net.md_5.bungee.api.ChatMessageType;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class WinCommand implements CommandExecutor {

    public WinCommand() {
        new StateDependentCommand(ArenaMode.Event, FightState.Ingame, "win", this);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if(!(sender instanceof Player)) {
            return false;
        }
        Player p = (Player) sender;

        if (!Config.isReferee(p)) {
            FightSystem.getMessage().sendPrefixless("NOT_FIGHTLEADER", p, ChatMessageType.ACTION_BAR);
            return false;
        }

        if(args.length == 0){
            FightSystem.getMessage().sendPrefixless("WIN_HELP", p);
            return false;
        }

        if(args[0].equalsIgnoreCase("tie")){
            FightSystem.setSpectateState(null, "Referee", "WIN_FIGHTLEADER");
            return false;
        }

        for(FightTeam team : Fight.teams()) {
            if(args[0].equalsIgnoreCase(team.getName())){
                FightSystem.setSpectateState(team, "Referee", "WIN_FIGHTLEADER");
                return false;
            }
        }
        return false;
    }
}
