/* 
    This file is a part of the SteamWar software.
    
    Copyright (C) 2020  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

package de.steamwar.fightsystem.listener;

import de.steamwar.fightsystem.ArenaMode;
import de.steamwar.fightsystem.Config;
import de.steamwar.fightsystem.FightSystem;
import de.steamwar.fightsystem.fight.Fight;
import de.steamwar.fightsystem.fight.FightTeam;
import de.steamwar.fightsystem.states.FightState;
import de.steamwar.fightsystem.states.StateDependentListener;
import de.steamwar.sql.SteamwarUser;
import de.steamwar.sql.UserPerm;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

public class TestJoin implements Listener {

    public TestJoin() {
        new StateDependentListener(ArenaMode.Test, FightState.All, this);
    }

    @EventHandler
    public void handlePlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        FightTeam fightTeam = Fight.getPlayerTeam(player);

        if(Config.ReplayID != 0 && !SteamwarUser.get(player.getUniqueId()).hasPerm(UserPerm.MODERATION)) {
            FightSystem.getMessage().send("CHECK_JOIN_DENIED", player);
            player.kickPlayer("");
            return;
        }

        if (fightTeam == null && Fight.teams().stream().anyMatch(team -> team.canbeLeader(player))) {
            FightSystem.getMessage().send("TEST_BECOME_LEADER", player);
        }

        player.setOp(true);

        if(FightState.getFightState() == FightState.PRE_LEADER_SETUP){
            FightState.setFightState(FightState.PRE_SCHEM_SETUP);
            FightState.setFightState(FightState.POST_SCHEM_SETUP);
        }
    }
}
