/*
    This file is a part of the SteamWar software.

    Copyright (C) 2021  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.utils;

import com.comphenix.tinyprotocol.Reflection;
import de.steamwar.core.VersionDependent;
import de.steamwar.fightsystem.FightSystem;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;

public interface BlockIdWrapper {
    Class<?> worldServer = Reflection.getClass("{nms.server.level}.WorldServer");
    Reflection.MethodInvoker getWorldHandle = Reflection.getTypedMethod(Reflection.getClass("{obc}.CraftWorld"), "getHandle", worldServer);

    Class<?> craftPlayer = Reflection.getClass("{obc}.entity.CraftPlayer");
    Class<?> entityPlayer = Reflection.getClass("{nms.server.level}.EntityPlayer");
    Reflection.MethodInvoker getPlayer = Reflection.getTypedMethod(craftPlayer, "getHandle", entityPlayer);

    BlockIdWrapper impl = VersionDependent.getVersionImpl(FightSystem.getPlugin());

    Material idToMaterial(int blockState);
    int blockToId(Block block);
    void setBlock(World world, int x, int y, int z, int blockState);

    void trackEntity(Player player, int entity);
    void untrackEntity(Player player, int entity);
}
