/*
    This file is a part of the SteamWar software.

    Copyright (C) 2021  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.utils;

import de.steamwar.core.VersionDependent;
import de.steamwar.fightsystem.FightSystem;
import org.bukkit.DyeColor;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.block.BlockPhysicsEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public interface FlatteningWrapper {
    FlatteningWrapper impl = VersionDependent.getVersionImpl(FightSystem.getPlugin());

    DyeColor getSilver();

    boolean isWater(Block block);
    boolean removeWater(Block block);

    boolean containsBlockMeta(ItemMeta meta);
    boolean hasAttributeModifier(ItemStack stack);

    boolean doRecord(BlockPhysicsEvent e);

    void forceLoadChunk(World world, int cX, int cZ);

    boolean checkPistonMoving(Block block);

    boolean isFacingWater(Block dispenser);

    boolean isCrouching(Player player);
    void sendBlockChange(Player player, Block block, Material type);
}
