/*
    This file is a part of the SteamWar software.

    Copyright (C) 2021  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.fightsystem.utils;

import com.sk89q.worldedit.WorldEditException;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import com.sk89q.worldedit.math.transform.AffineTransform;
import de.steamwar.core.VersionDependent;
import de.steamwar.fightsystem.FightSystem;
import de.steamwar.sql.SchematicNode;
import org.bukkit.DyeColor;
import org.bukkit.Location;
import org.bukkit.util.Vector;

import java.io.IOException;

public interface WorldeditWrapper {
    WorldeditWrapper impl = VersionDependent.getVersionImpl(FightSystem.getPlugin());

    void replaceTeamColor(Clipboard clipboard, DyeColor c) throws WorldEditException;
    int getWaterDepth(Clipboard clipboard);
    void pasteClipboard(Clipboard clipboard, Location position, Vector offset, AffineTransform aT);
    Vector getDimensions(Clipboard clipboard);
    Clipboard loadChar(String charName) throws IOException;
    void saveSchem(SchematicNode schem, Region region, int minY) throws WorldEditException;
}
