/* 
    This file is a part of the SteamWar software.
    
    Copyright (C) 2020  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

package de.steamwar.fightsystem.winconditions;

import de.steamwar.fightsystem.events.TeamDeathEvent;
import de.steamwar.fightsystem.fight.Fight;
import de.steamwar.fightsystem.fight.FightTeam;
import de.steamwar.fightsystem.states.FightState;
import de.steamwar.fightsystem.states.StateDependentListener;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class WinconditionAllDead extends Wincondition implements Listener {

    public WinconditionAllDead(){
        super("AllDead");
        new StateDependentListener(Winconditions.ALL_DEAD, FightState.Ingame, this);
    }

    @EventHandler
    public void handlePlayerDeath(TeamDeathEvent event) {
        FightTeam team = event.getFightPlayer().getTeam();

        if(team.getAlivePlayers() > 0)
            return;

        win(Fight.getOpposite(team), "WIN_ALL_DEAD", team.getPrefix());
    }
}
