# FightSystem

## Server setup

1. Install a WorldEdit plugin and the FightSystem plugin on the server
2. Start the server once (will instantly shutdown due to missing FightSystem configuration)
3. Configure FightSystem by modifying `plugins/FightSystem/config.yml`
4. Create a `backup` folder inside your world folder and copy your `region` folder and `level.dat` into it
5. Create a `config.yml` in the world folder and configure the file as described at the end of `plugins/FightSystem/config.yml`
6. Start and join the server (as op), create a basic kit, save it with `/ak [kitname]`
7. Configure the kit as default kit
8. Restart the server and have fun!

If you don't want FightSystem taking control over spawning and the whole world, set `Arena.Leaveable = true`.
To start a server in the testarena mode start the server with the flag `-DfightID=-1` prior to `-jar`.

## Compiling

Building SteamWar.de software requires certain libraries,
which cannot be provided over traditional ways (like maven)
due to copyright issues with compiled Spigot packages.
The following libraries are required to be in the `lib`
directory exactly named like in the list:

- `Spigot-1.8.jar`            https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.8.9)
- `Spigot-1.9.jar`            https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.9.4)
- `Spigot-1.10.jar`           https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.10.2)
- `Spigot-1.12.jar`           https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.12.2)
- `Spigot-1.14.jar`           https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.14.4)
- `Spigot-1.15.jar`           https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.15.2)
- `Spigot-1.18.jar`           https://hub.spigotmc.org/jenkins/job/BuildTools/ (1.18.2, Use the jar from Spigot/Spigot-Server/target)
- `SpigotCore.jar`            https://steamwar.de/devlabs/SteamWar/SpigotCore
- `WorldEdit-1.12.jar`        https://dev.bukkit.org/projects/worldedit/files (6.1.9)
- `WorldEdit-1.15.jar`        https://dev.bukkit.org/projects/worldedit/files (newest)
